DOUBLE PRECISION FUNCTION ran_norm(mean,stdev)

  ! Generate a random number from the normal distribution 
  USE global 
  IMPLICIT NONE

  DOUBLE PRECISION :: mean, stdev, ran1,ran2


  ! Local
  DOUBLE PRECISION :: w, x1,x2

  ! First two numbers random numbers
  w = 2.0d0
  DO WHILE (w .GE. 1.0d0)
    x1 = 2.0d0*random(idum) - 1.0d0
    x2 = 2.0d0*random(idum) - 1.0d0
    w = x1**2 + x2**2
  ENDDO
    ran_norm = x1*dSQRT(-2.0d0*dLOG(w)/w)*stdev + mean
 

END FUNCTION ran_norm
