SUBROUTINE ran_norm3(rnorm3,mean,sigma)
   
    USE global
    IMPLICIT NONE
    INCLUDE 'mpif.h'
 
    ! Passed
    DOUBLE PRECISION,DIMENSION(3) :: rnorm3, mean
    DOUBLE PRECISION :: sigma
    
    ! Local 
    DOUBLE PRECISION :: w, x1,x2

    ! First two numbers random numbers        
    w = 2.0d0
    DO WHILE (w .GE. 1)
      x1 = 2.0d0*random(idum) - 1.0d0
      x2 = 2.0d0*random(idum) - 1.0d0
      w = x1**2 + x2**2
    ENDDO
     rnorm3(1) = x1*dSQRT(-2.0d0*dLOG(w)/w)
     rnorm3(2) = x2*dSQRT(-2.0d0*dLOG(w)/w)

    ! Last random number
    w = 2.0d0
    DO WHILE (w .GE. 1)
      x1 = 2.0d0*random(idum) - 1.0d0
      x2 = 2.0d0*random(idum) - 1.0d0
      w = x1**2 + x2**2
    ENDDO
      rnorm3(3) = x1*dSQRT(-2.0d0*dLOG(w)/w)

     ! Scale by sigma (scalar)
     rnorm3 = rnorm3*sigma

     ! Shift by the mean (vector)
     rnorm3 = rnorm3 + mean
    
END SUBROUTINE  ran_norm3
