SUBROUTINE trial_move

  USE global
  IMPLICIT NONE
  INCLUDE 'mpif.h'

  ! Local
  REAL :: ran,pmove

  ! Generate a random number
  ran = random(idum)

    SELECT CASE(ensmbl)

      CASE(1) ! CEMC

        CALL md_move
   
      CASE(2) ! NPT


        ! Select a trial move
        IF(ran .LE. 0.33333d0) THEN
          CALL volchng_npt
        ELSE
          CALL md_move
        ENDIF      
             
      CASE DEFAULT
        
        WRITE(*,*) 'FATAL ERROR: INVALID ENSEMBLE SELECTED IN TRIAL_MOVE SUBROUTINE'
        STOP

    END SELECT


  RETURN

END SUBROUTINE trial_move
